using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MCL_Gen;

namespace GenExample
{
    public partial class Form1 : Form
    {
        
        public MCL_Gen.USB_Gen MyGen = new MCL_Gen.USB_Gen();
        double Freq1;
        float Power1;


        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {   
            string SN = "";

            // trying to connect the generator
            int status1 = MyGen.Connect(SN);

            // in case the connection Failed
            // for example the usb is not connected
            if (status1 == 0)
            {
                MessageBox.Show("The Connection Failed , Please Check the USB cable");
                Close();
            }



        }

        // set the RF signal ON
        private void RF_ON_CheckedChanged(object sender, EventArgs e)
        {
            int status1 = MyGen.SetPowerON();
        }

        // set the RF signal OFF
        private void RF_OFF_CheckedChanged(object sender, EventArgs e)
        {
            int status1 = MyGen.SetPowerOFF();
        }


        // Set the Generator Signal to a specific Freq and Power
        private void SetButton_Click(object sender, EventArgs e)
        {
            if (Freq.Text == "" | Power.Text == "")
            {
                MessageBox.Show("Please Insert Freq And Power");
                return;

            }
            else 
            {
                Freq1 = double.Parse(Freq.Text);
                Power1 = float.Parse(Power.Text);
                int status1 = MyGen.SetFreqAndPower(Freq1,Power1,(short)0);
                RF_ON.Enabled = true;
                RF_OFF.Enabled = true;

            
            }




        }

        private void ExitButton_Click(object sender, EventArgs e)
        {
            int status1 = MyGen.SetPowerOFF();
            MyGen.Disconnect();
            Close();
        }
    }
}