#ifndef _MCLGEN_H
#define _MCLGEN_H

#include <cviauto.h>

#ifdef __cplusplus
    extern "C" {
#endif
extern const IID MCLGen_IID__USB_Gen;

HRESULT CVIFUNC MCLGen_New_USB_Gen (const char *server,
                                    int supportMultithreading, LCID locale,
                                    int reserved, CAObjHandle *objectHandle);

HRESULT CVIFUNC MCLGen_Open_USB_Gen (const char *fileName, const char *server,
                                     int supportMultithreading, LCID locale,
                                     int reserved, CAObjHandle *objectHandle);

HRESULT CVIFUNC MCLGen_Active_USB_Gen (const char *server,
                                       int supportMultithreading, LCID locale,
                                       int reserved, CAObjHandle *objectHandle);

HRESULT CVIFUNC MCLGen__USB_GenGetStatus2 (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, VBOOL *status2);

HRESULT CVIFUNC MCLGen__USB_GenSetStatus2 (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo, VBOOL status2);

HRESULT CVIFUNC MCLGen__USB_GenGet_Address (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo, short *arg1);

HRESULT CVIFUNC MCLGen__USB_GenGet_Available_Address_List (CAObjHandle objectHandle,
                                                           ERRORINFO *errorInfo,
                                                           char **add_List,
                                                           short *arg2);

HRESULT CVIFUNC MCLGen__USB_GenSet_Address (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo, short address,
                                            unsigned char *arg2);

HRESULT CVIFUNC MCLGen__USB_GenGetFirmware (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo, short *arg1);

HRESULT CVIFUNC MCLGen__USB_GenGetExtFirmware (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               unsigned char *a0,
                                               unsigned char *a1,
                                               unsigned char *a2,
                                               unsigned char *a3,
                                               char **docFirmware, short *arg6);

HRESULT CVIFUNC MCLGen__USB_GenGetGenStatus (CAObjHandle objectHandle,
                                             ERRORINFO *errorInfo,
                                             unsigned char *locked,
                                             short *powerIsOn, double *fr,
                                             float *pr, VARIANT *UNLEVELHigh,
                                             VARIANT *UNLEVELLow, short *arg7);

HRESULT CVIFUNC MCLGen__USB_GenGetGenMinFreq (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo, float *arg1);

HRESULT CVIFUNC MCLGen__USB_GenGetGenMinPower (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo, float *arg1);

HRESULT CVIFUNC MCLGen__USB_GenExtRefDetected (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo, short *arg1);

HRESULT CVIFUNC MCLGen__USB_GenGetGenMaxPower (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo, float *arg1);

HRESULT CVIFUNC MCLGen__USB_GenGetGenMaxFreq (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo, float *arg1);

HRESULT CVIFUNC MCLGen__USB_GenGetGenStepFreq (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo, float *arg1);

HRESULT CVIFUNC MCLGen__USB_GenSet_Noise_Spur_Mode (CAObjHandle objectHandle,
                                                    ERRORINFO *errorInfo,
                                                    short nsm,
                                                    unsigned char *arg2);

HRESULT CVIFUNC MCLGen__USB_GenSet_Trigger (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            unsigned char *arg1);

HRESULT CVIFUNC MCLGen__USB_GenSet_Trigger_As_Input (CAObjHandle objectHandle,
                                                     ERRORINFO *errorInfo,
                                                     unsigned char *arg1);

HRESULT CVIFUNC MCLGen__USB_GenSet_Trigger_As_Output (CAObjHandle objectHandle,
                                                      ERRORINFO *errorInfo,
                                                      unsigned char *arg1);

HRESULT CVIFUNC MCLGen__USB_GenClear_Trigger (CAObjHandle objectHandle,
                                              ERRORINFO *errorInfo,
                                              unsigned char *arg1);

HRESULT CVIFUNC MCLGen__USB_GenGet_Noise_Spur_Mode (CAObjHandle objectHandle,
                                                    ERRORINFO *errorInfo,
                                                    short *nsm,
                                                    unsigned char *arg2);

HRESULT CVIFUNC MCLGen__USB_GenSetPower (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo, float pr,
                                         short triggerOut, unsigned char *arg3);

HRESULT CVIFUNC MCLGen__USB_GenResetCPU (CAObjHandle objectHandle,
                                         ERRORINFO *errorInfo,
                                         unsigned char *arg1);

HRESULT CVIFUNC MCLGen__USB_GenSetPowerON (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo,
                                           unsigned char *arg1);

HRESULT CVIFUNC MCLGen__USB_GenSetPowerOFF (CAObjHandle objectHandle,
                                            ERRORINFO *errorInfo,
                                            unsigned char *arg1);

HRESULT CVIFUNC MCLGen__USB_GenGetTriggerIn_Status (CAObjHandle objectHandle,
                                                    ERRORINFO *errorInfo,
                                                    short *arg1);

HRESULT CVIFUNC MCLGen__USB_GenSetFreqAndPower (CAObjHandle objectHandle,
                                                ERRORINFO *errorInfo, double fr,
                                                float pr, short triggerOut,
                                                unsigned char *arg4);

HRESULT CVIFUNC MCLGen__USB_GenSetFreq (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo, double fr,
                                        short triggerOut, unsigned char *arg3);

HRESULT CVIFUNC MCLGen__USB_GenGetDeviceTemperature (CAObjHandle objectHandle,
                                                     ERRORINFO *errorInfo,
                                                     float *arg1);

HRESULT CVIFUNC MCLGen__USB_GenGet_Available_SN_List (CAObjHandle objectHandle,
                                                      ERRORINFO *errorInfo,
                                                      char **SN_List,
                                                      short *arg2);

HRESULT CVIFUNC MCLGen__USB_GenGetStatus (CAObjHandle objectHandle,
                                          ERRORINFO *errorInfo, short *arg1);

HRESULT CVIFUNC MCLGen__USB_GenRead_ModelName (CAObjHandle objectHandle,
                                               ERRORINFO *errorInfo,
                                               char **modelName, short *arg2);

HRESULT CVIFUNC MCLGen__USB_GenRead_SN (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo, char **SN,
                                        short *arg2);

HRESULT CVIFUNC MCLGen__USB_GenConnect (CAObjHandle objectHandle,
                                        ERRORINFO *errorInfo, const char *SN,
                                        short *arg2);

HRESULT CVIFUNC MCLGen__USB_GenConnectByAddress (CAObjHandle objectHandle,
                                                 ERRORINFO *errorInfo,
                                                 short address, short *arg2);

HRESULT CVIFUNC MCLGen__USB_GenDisconnect (CAObjHandle objectHandle,
                                           ERRORINFO *errorInfo);
#ifdef __cplusplus
    }
#endif
#endif /* _MCLGEN_H */
