//==============================================================================
//
// Title:       CVI_Gen_Exm
// Purpose:     A short description of the application.
//
// Created on:  16/04/2009 at 12:49:04 by prog.
// Copyright:   . All Rights Reserved.
//
//==============================================================================

//==============================================================================
// Include files

#include "CVI_Gen.h"
#include <ansi_c.h>
#include <cvirte.h>     
#include <userint.h>
#include "CVI_Gen_Exm.h"
#include "toolbox.h"

//==============================================================================
// Constants

//==============================================================================
// Types

//==============================================================================
// Static global variables

static int panelHandle;

//==============================================================================
// Static functions

//==============================================================================
// Global variables

//==============================================================================
// Global functions

/// HIFN The main entry-point function.
int main (int argc, char *argv[])
{
    int error = 0;
    
    /* initialize and load resources */
    nullChk (InitCVIRTE (0, argv, 0));
    errChk (panelHandle = LoadPanel (0, "CVI_Gen_Exm.uir", PANEL));
    
    /* display the panel and run the user interface */
    errChk (DisplayPanel (panelHandle));
    errChk (RunUserInterface ());

Error:
    /* clean up */
    DiscardPanel (panelHandle);
    return 0;
}

//==============================================================================
// UI callback function prototypes

/// HIFN Exit when the user dismisses the panel.
int CVICALLBACK panelCB (int panel, int event, void *callbackData,
        int eventData1, int eventData2)
{
    if (event == EVENT_CLOSE)
        QuitUserInterface (0);
    return 0;
}


int CVICALLBACK SetFreqPower (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	CAObjHandle obj;	  
	MCLGen_New_USB_Gen(NULL,1, 	LOCALE_NEUTRAL,0,&obj);	   
	 MCLGen__USB_GenConnect(obj,NULL,"",0);
	 MCLGen__USB_GenSetFreqAndPower(obj,NULL,2000,-15,0,0);
	 MCLGen__USB_GenSetPowerON(obj,NULL,0);
	 MCLGen__USB_GenSetPowerOFF(obj,NULL,0);  
	 MCLGen__USB_GenDisconnect(obj,NULL);
	
	
	
//	MCLRFSwitchController_New_USB_RF_Switch (NULL, 1, LOCALE_NEUTRAL, 0, &obj);
//	  MCLRFSwitchController__USB_RF_SwitchConnect (obj, NULL, "",0);
//	  MCLRFSwitchController__USB_RF_SwitchSet_Switch (obj, NULL, &Sname, &val1, 0);
//	  MCLRFSwitchController__USB_RF_SwitchSet_Switch (obj, NULL, &Sname, &val0,0);
	
	
	
	return 0;
}
